;------------------------------------------------------------------------------
;     KOI8-R
;------------------------------------------------------------------------------
	device zxspectrum128
;------------------------------------------------------------------------------
COLOR_BLACK	equ	00h
COLOR_BLUE	equ	01h
COLOR_RED	equ	02h
COLOR_MAGENTA	equ	03h
COLOR_GREEN	equ	04h
COLOR_CYAN	equ	05h
COLOR_YELLOW	equ	06h
COLOR_WHILE	equ	07h
;------------------------------------------------------------------------------
C_INC		equ	COLOR_YELLOW
C_PAPER		equ	COLOR_BLUE
C_BORDER	equ	COLOR_BLUE
;------------------------------------------------------------------------------
CR		equ	0x0D
;------------------------------------------------------------------------------
RG_DAT		equ	0F8EFh
RG_DLL		equ	0F8EFh
RG_DLM		equ	0F9EFh
RG_FCR		equ	0FAEFh
RG_LCR		equ	0FBEFh
RG_MCR		equ	0FCEFh
RG_LSR		equ	0FDEFh
RG_MSR		equ	0FEEFh
RG_SPR		equ	0FFEFh
;------------------------------------------------------------------------------
;   
	MACRO	puts str
		call	__puts
		.db  str
		.db  00h
	ENDM
;        
	MACRO	putsln str
		call	__puts
		.db  str
		.db  0Dh,00h
	ENDM
;    - 0-65536
	MACRO	putnum adr
		ld	hl,adr
		call	1A28h
	ENDM
;     
	MACRO	cnsout	adr, cnst
		ld	bc,adr
		ld	a,cnst
		out	(c),a
	ENDM
;      A
	MACRO	inbca	adr
		ld	bc,adr
		in	a,(c)
	ENDM
;    A  
	MACRO	outbca	adr
		ld	bc,adr
		out	(c),a
	ENDM
;------------------------------------------------------------------------------
		org 6000h
StartP
;------------------------------------------------------------------------------
main:
;
infloop:
		di
		;   (  )
		ld	HL,2762h
		exx
		ld	IY,5C3Ah
		;  
		call	init_attr
		;  
		ld	a,2
		call	1601h
		;  
		putsln	"PentEvo serial runner."
		putsln	"Wait for serial connection."
		ei
		;   RS232
		call	setserial
		;  
		call	rec_hdr
		call	rec_data
		; ģ  
.wkey0:
		call	inkey
		jr c,	.wkey0
		;
		ld	hl,	(HEADER+09h)
		call	call_hl
		; ģ  
.wkey1:
		call	inkey
		jr c,	.wkey1
		;
		jr	infloop
;       HL
call_hl:
		jp	(hl)
;------------------------------------------------------------------------------
;  
setserial:
		putsln	"Serial port init (19200)"
		puts	"> "
		; 
		cnsout	RG_LCR,83h	; . . 
		cnsout	RG_DLM,00h
		cnsout	RG_DLL,06h	; 19200 = 115200/6
		cnsout	RG_LCR,03h	; . . 
		;  FIFO
		cnsout	RG_FCR,07h
		cnsout	RG_FCR,00h
		;
		ret
;------------------------------------------------------------------------------
;   ( -  A)
; CF=0 -  
; CF=1 -   
inkey:
		bit	5,(IY+01h)
		jr 	z,.nodata
		ld	a,(IY-50)
		res	5,(IY+01h)
		;
		scf	; CF=1
		ccf	; CF=0 (CF=!CF)
		ret
.nodata:
		scf	; CF=1
		ret
;------------------------------------------------------------------------------
;   .   -  . A
; CF=0 -  
; CF=1 -  
rdserial:
		inbca	RG_LSR
		;
		and	1		; // FIFO ɣ  ?
		jr	z, .nodata	;  -  
		inbca	RG_DAT
		;
		scf
		ccf	; CF=0
		ret
.nodata:
		scf	; CF=1
		ret
;------------------------------------------------------------------------------
;   A   
wrserial:
		push	af
.wloop:
		inbca	RG_LSR
		and	20h	; // FIFO  ?
		jr	z,.wloop
		pop	af
		outbca	RG_DAT
		ret
;------------------------------------------------------------------------------
;   (ASCIIZ)
; ......
; call __puts
; .db "",00h
; .....
__puts:
		pop	hl
.puts_loop:
		ld	a,(hl)
		or	a
		jr	z,	.puts_exit
		push	hl
		rst	10h
		pop	hl
		inc	hl
		jr	.puts_loop
.puts_exit:
		inc	hl
		push	hl
		ret
;------------------------------------------------------------------------------
;     
init_attr:
		ld	a,C_BORDER
		call	229Bh
		ld	a, C_INC | ( C_PAPER << 3 )
		ld	(5C8Dh),a
		call	0D6Bh
		ret
;------------------------------------------------------------------------------
;  17  HOBETA
;	0x00     FileName     0x08      TR-DOS file name
;	0x08     FileType     0x01      TR-DOS file type
;	0x09     StartAdr     0x02      start address of file
;	0x0B     FlLength     0x02      length of file (in bytes)
;	0x0D     FileSize     0x02      size of file (in sectors) 
;	0x0F     HdrCRC16     0x02      Control checksum of the 15 byte header
rec_hdr:
		ld	hl,	HEADER
		ld	b,	17
.next_byte:
		push	hl
		push	bc
		; ģ
.nord:
		call	rdserial
		jr c,	.nord
		;   -  
		pop	bc
		pop	hl
		;
		ld	(hl),a
		inc	hl
		;
		djnz	.next_byte
		;   
		ld	b,	9
		ld	hl,	HEADER
.next_s:
		push	hl
		push	bc
		ld	a,(hl)
		rst	10h
		pop	bc
		pop	hl
		inc	hl
		djnz	.next_s
		;
		putsln	"<"
		;
		ret
;------------------------------------------------------------------------------
rec_data:
		ld	hl,	(HEADER+09h)
		ld	bc,	(HEADER+0Bh)
.next_byte:
		push	hl
		push	bc
		; ģ
.nord:
		call	rdserial
		jr c,	.nord
		;   -  
		pop	bc
		pop	hl
		;
		ld	(hl),a
		inc	hl
		dec	bc
		ld	a,b
		or	c
		;
		jr	nz,	.next_byte
		putsln	"Loaded. Press any key to start."
		ret
;------------------------------------------------------------------------------
HEADER:
		.db 17
;------------------------------------------------------------------------------
EndP
;------------------------------------------------------------------------------
		savehob "serrun.$C","serrun.C",StartP,EndP-StartP
;		EMPTYTRD "testkoi.trd"
;		SAVETRD  "testkoi.trd","testkoi.C",StartTest,EndTest-StartTest
